<template>
  <table>
    <tr v-for="tip in tips" :key="tip.id">
      <td class="td-img">
        <img class="img-platform" :src="platformImgUrl(tip.platform)" />
      </td>
      <td>{{ formatDate(tip.payDate) }}</td>
      <td class="td-sats">
        <span>{{ tip.amount / 1000 }}</span>&nbsp;sats
      </td>
      <td class="td-message">{{ shortString(tip.message, 50) }}</td>
      <td class="td-memo">{{ formatMemo(tip.memo) }}</td>
    </tr>
  </table>
</template>

<script>
import { isToday } from "../utils/date.utils";

export default {
  props: {
    count: {
      type: Number,
      default: 10,
    },
  },
  computed: {
    tips() {
      return this.$store.state.tips.tips;
    },
  },
  async beforeCreate() {
    this.$store.dispatch("loadMyTips", this.count);
  },
  methods: {
    platformImgUrl(name) {
      return `${process.env.VUE_APP_API_URL}/files/img/platform/${name}.svg`;
    },
    formatDate(date) {
      var formatDate = "";
      if (date) {
        var d = new Date(date);
        d.setUTCHours(d.getHours());
        var options = { timeStyle: "short" };
        if (!isToday(d)) options.dateStyle = "short";
        formatDate = d.toLocaleString(navigator.language, options);
      }
      return formatDate;
    },
    formatMemo(memo) {
      if (memo && memo.startsWith("BitTip -")) {
        memo = memo.substring(8, memo.length);
      }
      return this.shortString(memo, 40);
    },
    shortString(text, maxLength) {
      if (text && text.length > maxLength) {
        text = text.substring(0, maxLength) + "...";
      }
      return text;
    },
  },
};
</script>

<style lang="scss" scoped>
table {
  width: 100%;

  td {
    padding: 0 1.7vw 10px 0;
    width: 0px;

    &.td-img{
        padding-right: 10px;
    }

    &.td-sats, &.td-message, &.td-memo {
      width: fit-content;
    }

    &.td-sats span, &.td-message{
        font-weight: 600;
    }

    &.td-sats span{
        font-size: 1.3em;
    }

    .img-platform {
      width: 25px;
      height: 25px;
    }
  }

  td:last-child {
    padding-right: 0;
  }
}
</style>